library(stockassessment)
load("run/model.RData")
FC<-list()
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,1,1), label="SQ all years", processNoise=FALSE, addTSB=TRUE)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,0.000001,0.000001, 0.000001), label="SQ then zero", processNoise=FALSE, addTSB=TRUE)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,0.23,0.23, 0.23), label="SQ then Fmsy", processNoise=FALSE, addTSB=TRUE)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,0.60,0.60, 0.60), label="SQ then Fp05", processNoise=FALSE, addTSB=TRUE)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,0.62,0.62, 0.62), label="SQ then Fpa", processNoise=FALSE, addTSB=TRUE)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,0.85,0.85, 0.85), label="SQ then Flim", processNoise=FALSE, addTSB=TRUE)
#set.seed(12345)

Ry<-1996:2020     # assessment year-1 
Fsq<-0.403        # value from SAM
 # gives exactly Fsq value
set.seed(12345)
FC[[length(FC)+1]]  <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(Fsq, Fsq,Fsq,Fsq),rec.years=Ry, label="Rec 1996-2020, SQ all years", processNoise=FALSE,addTSB=TRUE, year.base=2021) 
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(Fsq,Fsq,0.000001, 0.000001), rec.years=Ry, label="Rec 1996-2020, SQ then zero", processNoise=FALSE, addTSB=TRUE, year.base=2021)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(Fsq,Fsq,0.23, 0.23), rec.years=Ry, label="Rec 1996-2020, SQ then Fmsy", processNoise=FALSE, addTSB=TRUE, year.base=2021)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(Fsq,Fsq,0.60, 0.60), rec.years=Ry, label="Rec 1996-2020, SQ then Fp05", processNoise=FALSE, addTSB=TRUE, year.base=2021)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(Fsq,Fsq,0.62, 0.62), rec.years=Ry, label="Rec 1996-2020, SQ then Fpa", processNoise=FALSE, addTSB=TRUE, year.base=2021)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(Fsq,Fsq,0.85, 0.85), rec.years=Ry, label="Rec 1996-2020, SQ then Flim", processNoise=FALSE, addTSB=TRUE, year.base=2021)

# Gives Fsq close but not exactly
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,1,1), rec.years=Ry, label="Rec 1996-2020, SQ all years", processNoise=FALSE, addTSB=TRUE, year.base=2021)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.000001, 0.000001), rec.years=Ry, label="Rec 1996-2020, SQ then zero", processNoise=FALSE, addTSB=TRUE, year.base=2021)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.23, 0.23), rec.years=Ry, label="Rec 1996-2020, SQ then Fmsy", processNoise=FALSE, addTSB=TRUE)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.60, 0.60), rec.years=Ry, label="Rec 1996-2020, SQ then Fp05", processNoise=FALSE, addTSB=TRUE)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.62, 0.62), rec.years=Ry, label="Rec 1996-2020, SQ then Fpa", processNoise=FALSE, addTSB=TRUE)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.85, 0.85), rec.years=Ry, label="Rec 1996-2020, SQ then Flim", processNoise=FALSE, addTSB=TRUE)

save(FC, file="run/forecast.RData")

